<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8">
        <meta content="width=device-width, initial-scale=1.0" name="viewport">
        <title>Row Groups</title>
        <style>
            .styled {
                --space: 0.25em;
                width: 100%;
                font-family: sans-serif;
            }
            .styled th,
            .styled td {
                text-align: center;
            }
            .styled th:first-child,
            .styled td:first-child {
                text-align: left;
                padding-left: var(--space);
            }
            .styled th:last-child,
            .styled td:last-child {
                text-align: right;
                padding-right: var(--space);
            }
            .styled thead {
                background-color: #4CAF50;
                color: #fff;
            }
            .styled tbody td {
                text-transform: capitalize;
            }
            .styled tbody tr:nth-child(even) {
                background-color: rgba(76, 175, 79, 0.2);
            }
            .styled tfoot tr {
                background-color: #555;
                color: #fff;
            }
            .styled tfoot th {
                padding: calc(2 * var(--space)) 0;
            }
        </style>
    </head>
    <body>
        <h1>Row Groups</h1>

        <h2>No Style</h2>
        <table id="t1">
            <thead>
                <tr> <th>Name</th> <th>Stock Count</th> <th>Price</th> </tr>
            </thead>
            <tbody class="data"></tbody>
            <tfoot>
                <tr> <th></th> <th class="count"></th> <th class="price"></th> </tr>
            </tfoot>
        </table>

        <h2>Styled</h2>
        <table id="t2" class="styled">
            <thead>
                <tr> <th>Name</th> <th>Stock Count</th> <th>Price</th> </tr>
            </thead>
            <tbody class="data"></tbody>
            <tfoot>
                <tr> <th></th> <th class="count"></th> <th class="price"></th> </tr>
            </tfoot>
        </table>

        <script>
            const fruitNames = [
                'apple',
                'banana',
                'coco nut',
                'date plum',
                'elderberry',
                'fig',
                'grape',
                'honeydew melon',
                'iceberg lettuce',
                'jerusalem artichoke',
                'kiwi fruit',
            ];

            function generate(name) {
                const price = 1 + Math.random() * 15;
                const count = Math.round(Math.random() * 10);
                return {name, price, count};
            }

            function toCurrency(amount, currency='EUR') {
                return new Intl.NumberFormat('en-UK', {
                    style: 'currency',
                    currency: currency
                }).format(amount);
            }

            function mkRow(p) {
                const tr = document.createElement('tr');
                tr.innerHTML = `
                    <td>${ p.name }</td>
                    <td>${ p.count }</td>
                    <td>${toCurrency(p.price)}</td>
                    `.replace(/[\s\n\r]+/, ' ');
                return tr;
            }

            function populate(id, names=fruitNames) {
                const dataElem  = document.querySelector(`#t${id} .data`);
                const countElem = document.querySelector(`#t${id} .count`);
                const priceElem = document.querySelector(`#t${id} .price`);

                let totalCount=0, totalPrice = 0;
                names.forEach(name => {
                    const p = generate(name);
                    totalCount += p.count;
                    totalPrice += p.price;
                    dataElem.appendChild(mkRow(p));
                });
                countElem.innerText = totalCount;
                priceElem.innerText = toCurrency(totalPrice);
            }

            populate(1);
            populate(2);
        </script>
    </body>
</html>
